using System.Collections;
using System.Collections.Generic;
using UnityEngine;


namespace ZEGO
{
    // The define of error code.
    //
    // Description: Developers can find the details of the error code in the developer documentation website according to the error code.
    //
    // Use cases: It can be used to collect and record errors in the process of using the SDK.

    public enum ZIMErrorCode
    {

        Success = 0,
        Failed = 1,

        CommonModuleParamsInvalid = 6000001,
        CommonModuleEngineNotInit = 6000002,
        CommonModuleInvalidAppid = 6000003,
        CommonModuleTriggerSdkFrequencyLimit = 6000004,
        CommonModuleTriggerServerFrequencyLimit = 6000005,
        CommonModuleSwitchServerError = 6000006,
        CommonModuleImServerError = 6000007,
        CommonModuleImDatabaseError = 6000008,
        CommonModuleImServerDisconnect = 6000009,
        CommonModuleUploadLogError = 6000010,
        CommonModuleUserIsNotExist = 6000011,
        CommonModuleUserInfoQueriedLimit = 6000012,
        CommonModuleUnsupportedRequest = 6000013,
        CommonModuleExceedDauLimit = 6000015,
        CommonModuleExceedMauLimit = 6000016,

        NetworkModuleCommonError = 6000101,
        NetworkModuleServerError = 6000102,
        NetworkModuleTokenInvalid = 6000103,
        NetworkModuleNetworkError = 6000104,
        NetworkModuleTokenExpired = 6000106,
        NetworkModuleTokenVersionError = 6000107,
        NetworkModuleTokenTimeIsTooShort = 6000108,
        NetworkModuleUserHasAlreadyLogged = 6000111,
        NetworkModuleUserIsNotLogged = 6000121,
        NetworkModuleUserOffline = 6000123,

        MessageModuleCommonError = 6000201,
        MessageModuleServerError = 6000202,
        MessageModuleSendMessageFailed = 6000203,
        MessageModuleTargetDoesNotExist = 6000204,
        MessageModuleFileNotExist = 6000211,
        MessageModuleFileServerError = 6000212,
        MessageModuleFileTypeUnsupported = 6000213,
        MessageModuleFileSizeInvalid = 6000214,
        MessageModuleFileDurationInvalid = 6000215,
        MessageModuleFilePermissionDenied = 6000216,
        MessageModuleFileDownloadFailed = 6000217,
        MessageModuleFileDownloadLimit = 6000218,
        MessageModuleFileDownloadUrlNotFound = 6000219,
        MessageModuleFileDownloadHttpRequestServerError = 6000220,
        MessageModuleAuditRejected = 6000221,
        MessageModuleAuditFailed = 6000222,
        MessageModuleAuditCustomSentRejected = 6000230,
        MessageModuleCallError = 6000270,
        MessageModuleCancelCallError = 6000271,
        MessageModuleCallServerError = 6000272,
        MessageModuleIsNotInvitor = 6000273,
        MessageModuleIsNotInvitee = 6000274,
        MessageModuleCallAlreadyExists = 6000275,
        MessageModuleCallDoesNotExist = 6000276,
        MessageModuleReceiptReadError = 6000277,
        MessageModuleMessageExceedsRevokeTime = 6000278,
        MessageModuleMessageHasBeenRevoked = 6000279,
        MessageModuleMessageReactionTypeExisted = 6000280,
        MessageModuleCallInviteUserDoesNotExist = 6000281,

        RoomModuleCommonError = 6000301,
        RoomModuleServerError = 6000302,
        RoomModuleCreateRoomError = 6000303,
        RoomModuleJoinRoomError = 6000304,
        RoomModuleLeaveRoomError = 6000306,
        RoomModuleRoomMemberQueryFailed = 6000310,
        RoomModuleRoomMemberQueryFailedCompletely = 6000311,
        RoomModuleUserIsAlreadyInTheRoom = 6000320,
        RoomModuleUserIsNotInTheRoom = 6000321,
        RoomModuleTheRoomDoesNotExist = 6000322,
        RoomModuleTheRoomAlreadyExists = 6000323,
        RoomModuleTheNumberOfExistingRoomsHasReachedLimit = 6000324,
        RoomModuleTheNumberOfJoinedRoomsHasReachedLimit = 6000325,
        RoomModuleTheRoomIsConnecting = 6000326,
        RoomModuleRoomAttributesCommonError = 6000330,
        RoomModuleRoomAttributesOperationFailedCompletely = 6000331,
        RoomModuleRoomAttributesOperationFailedPartly = 6000332,
        RoomModuleRoomAttributesQueryFailed = 6000333,
        RoomModuleTheNumberOfRoomAttributesExceedsLimit = 6000334,
        RoomModuleTheLengthOfRoomAttributeKeyExceedsLimit = 6000335,
        RoomModuleTheLengthOfRoomAttributeValueExceedsLimit = 6000336,
        RoomModuleTheTotalLengthOfRoomAttributesValueExceedsLimit = 6000337,
        RoomModuleRoomMemberAttributesCommonError = 6000350,
        RoomModuleTheTotalLengthOfRoomMemberAttributesExceedsLimit = 6000351,
        RoomModuleTheLengthOfRoomMemberAttributesKeyExceedsLimit = 6000352,
        RoomModuleTheLengthOfRoomMemberAttributesValueExceedsLimit = 6000353,
        RoomModuleTheMemberNumberOfRoomMemberAttributesExceedsLimit = 6000357,
        ZpnsModulePushIdInvalid = 6000401,

        GroupModuleCommonError = 6000501,
        GroupModuleServerError = 6000502,
        GroupModuleCreateGroupError = 6000503,
        GroupModuleDismissGroupError = 6000504,
        GroupModuleJoinGroupError = 6000505,
        GroupModuleLeaveGroupError = 6000506,
        GroupModuleKickOutGroupMemberError = 6000507,
        GroupModuleInviteUserIntoGroupError = 6000508,
        GroupModuleTransferOwnerError = 6000509,
        GroupModuleUpdateGroupInfoError = 6000510,
        GroupModuleQueryGroupInfoError = 6000511,
        GroupModuleGroupAttributesOperationFailed = 6000512,
        GroupModuleGroupAttributesQueryFailed = 6000513,
        GroupModuleUpdateGroupMemberInfoError = 6000514,
        GroupModuleQueryGroupMemberInfoError = 6000515,
        GroupModuleQueryGroupListError = 6000516,
        GroupModuleQueryGroupMemberListError = 6000517,
        GroupModuleUserIsNotInTheGroup = 6000521,
        GroupModuleMemberIsAlreadyInTheGroup = 6000522,
        GroupModuleGroupDoesNotExist = 6000523,
        GroupModuleGroupAlreadyExists = 6000524,
        GroupModuleGroupMemberHasReachedLimit = 6000525,
        GroupModuleGroupAttributeDoesNotExist = 6000526,
        GroupModuleTheNumberOfGroupAttributesExceedsLimit = 6000531,
        GroupModuleTheLengthOfGroupAttributeKeyExceedsLimit = 6000532,
        GroupModuleTheLengthOfGroupAttributeValueExceedsLimit = 6000533,
        GroupModuleTheTotalLengthOfGroupAttributeValueExceedsLimit = 6000534,
        GroupModuleNoCorrespondingOperationAuthority = 6000541,
        GroupModuleGroupDatabaseError = 6000542,

        ConversationModuleCommonError = 6000601,
        ConversationModuleServerError = 6000602,
        ConversationModuleConversationDoesNotExist = 6000603,
        ConversationModuleConversationPinnedListReachedLimit = 6000604,

        DatabaseModuleOpenDatabaseError = 6000701,
        DatabaseModuleModifyDatabaseError = 6000702,
        DatabaseModuleDeleteDatabaseError = 6000703,
        DatabaseModuleSeleteDatabaseError = 6000704,
        DatabaseModuleDbIsNotOpened = 6000710
    };
}
