using System.Runtime.InteropServices;
using System;

namespace ZEGO
{
    public class IZIMInternal
    {

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_get_version", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern System.IntPtr zim_get_version();

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_set_pushid", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_set_pushid([In()][MarshalAsAttribute(UnmanagedType.LPStr)] string pushid);

#if UNITY_ANDROID && !UNITY_EDITOR
        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "GetJVM", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern System.IntPtr GetJVM();

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_set_android_env", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_set_android_env(System.IntPtr jvm, System.IntPtr context);
#endif

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_write_custom_log", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_write_custom_log([In()][MarshalAsAttribute(UnmanagedType.LPStr)] string custom_log, [In()][MarshalAsAttribute(UnmanagedType.LPStr)] string module_name);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_create", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_create(ref System.IntPtr handle, uint app_id, [In()][MarshalAsAttribute(UnmanagedType.LPStr)] string app_sign);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_get_instance", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_get_instance(ref System.IntPtr handle);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_destroy", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_destroy(ref System.IntPtr handle);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_set_log_config", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_set_log_config(zim_log_config config);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_get_log_path", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern System.IntPtr zim_get_log_path();

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_log_uploaded_callback(System.IntPtr handle, zim_error error_info, int sequence);


        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_log_uploaded_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_log_uploaded_callback(System.IntPtr handle, zim_on_log_uploaded_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_upload_log", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_upload_log(System.IntPtr handle, ref int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_set_cache_config", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_set_cache_config(zim_cache_config config);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_set_advanced_config", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_set_advanced_config([In()][MarshalAsAttribute(UnmanagedType.LPStr)] string key, [In()][MarshalAsAttribute(UnmanagedType.LPStr)] string value);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_logged_in_callback(System.IntPtr handle, zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_logged_in_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_logged_in_callback(System.IntPtr handle, zim_on_logged_in_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_login", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_login(System.IntPtr handle, zim_user_info user_info, [In()][MarshalAsAttribute(UnmanagedType.LPStr)] string token, ref int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_logout", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_logout(System.IntPtr handle);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_token_renewed_callback(System.IntPtr handle, [In()][MarshalAsAttribute(UnmanagedType.LPStr)] string token, zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_token_renewed_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_token_renewed_callback(System.IntPtr handle, zim_on_token_renewed_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_renew_token", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_renew_token(System.IntPtr handle, [In()][MarshalAsAttribute(UnmanagedType.LPStr)] string token, ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_users_info_queried_callback(System.IntPtr handle, System.IntPtr user_list,
            uint user_list_length, System.IntPtr error_user_list, uint error_user_list_length,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_users_info_queried_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_users_info_queried_callback(System.IntPtr handle,
            zim_on_users_info_queried_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_query_users_info", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_query_users_info(System.IntPtr handle,
            [MarshalAs(UnmanagedType.LPArray, ArraySubType = UnmanagedType.LPStr, SizeParamIndex = 6)] string[] user_id_list, uint user_id_list_length,
            zim_users_info_query_config config,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_user_name_updated_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string user_name, zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_user_name_updated_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_user_name_updated_callback(System.IntPtr handle,
            zim_on_user_name_updated_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_update_user_name", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_update_user_name(System.IntPtr handle, [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string user_name,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_user_avatar_url_updated_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string user_avatar_url, zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_user_avatar_url_updated_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_user_avatar_url_updated_callback(System.IntPtr handle,
            zim_on_user_avatar_url_updated_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_update_user_avatar_url", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_update_user_avatar_url(System.IntPtr handle, [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string user_avatar_url,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_user_extended_data_updated_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string user_extended_data,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_user_extended_data_updated_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_user_extended_data_updated_callback(System.IntPtr handle,
            zim_on_user_extended_data_updated_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_update_user_extended_data", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_update_user_extended_data(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string user_extended_data, ref int sequence);


        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_conversation_queried_callback(System.IntPtr handle,
            zim_conversation conversation, zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_conversation_queried_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_conversation_queried_callback(System.IntPtr handle,
            zim_on_conversation_queried_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_query_conversation", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_query_conversation(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string conversation_id, System.Int32 conversation_type,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_conversation_list_queried_callback(System.IntPtr handle,
            System.IntPtr conversations_list, uint conversation_list_length,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_conversation_list_queried_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_conversation_list_queried_callback(System.IntPtr handle,
            zim_on_conversation_list_queried_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_query_conversation_list", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_query_conversation_list(System.IntPtr handle,
            zim_conversation_query_config config, ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_conversation_pinned_list_queried_callback(System.IntPtr handle,
            System.IntPtr conversations_list, uint conversation_list_length, zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_conversation_pinned_list_queried_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_conversation_pinned_list_queried_callback(System.IntPtr handle,
    zim_on_conversation_pinned_list_queried_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_query_conversation_pinned_list", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_query_conversation_pinned_list(System.IntPtr handle,
    zim_conversation_query_config config, ref int sequence);



        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_conversation_pinned_state_updated_callback(System.IntPtr handle,
                    [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string conversation_id, System.Int32 conversation_type,
                    zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_conversation_pinned_state_updated_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_conversation_pinned_state_updated_callback(System.IntPtr handle,
            zim_on_conversation_pinned_state_updated_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_update_conversation_pinned_state", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_update_conversation_pinned_state(System.IntPtr handle, bool is_pinned,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string conversation_id, System.Int32 conversation_type,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_conversation_deleted_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string conversation_id, System.Int32 conversation_type,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_conversation_deleted_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_conversation_deleted_callback(System.IntPtr handle,
            zim_on_conversation_deleted_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_delete_conversation", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_delete_conversation(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string conversation_id, System.Int32 conversation_type,
            zim_conversation_delete_config config, ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_message_local_extended_data_updated_callback(System.IntPtr handle,
        zim_message message,
        zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_message_local_extended_data_updated_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_message_local_extended_data_updated_callback(System.IntPtr handle,
            zim_on_message_local_extended_data_updated_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_update_message_local_extended_data", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_update_message_local_extended_data(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string local_extended_data, zim_message message,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_messages_searched_callback(
        System.IntPtr handle, [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string conversation_id, System.Int32 conversation_type,
        System.IntPtr message_list, uint message_list_length,
         ref zim_message next_message, zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_messages_searched_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_messages_searched_callback(System.IntPtr handle,
            zim_on_messages_searched_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_search_local_messages", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_search_local_messages(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string conversation_id, System.Int32 conversation_type,
            zim_message_search_config config, ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_messages_global_searched_callback(
        System.IntPtr handle, System.IntPtr message_list, uint message_list_length,
         ref zim_message next_message, zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_messages_global_searched_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_messages_global_searched_callback(System.IntPtr handle,
            zim_on_messages_global_searched_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_search_global_local_messages", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_search_global_local_messages(System.IntPtr handle,
            zim_message_search_config config, ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_conversations_searched_callback(
        System.IntPtr handle, System.IntPtr conversation_search_info_list, uint conversation_search_info_list_length, uint next_flag,
        zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_conversations_searched_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_conversations_searched_callback(System.IntPtr handle,
            zim_on_conversations_searched_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_search_global_local_messages", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_search_local_conversations(System.IntPtr handle,
            zim_conversation_search_config config, ref int sequence);


        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_groups_searched_callback(
        System.IntPtr handle, System.IntPtr group_search_info_list, uint group_search_info_list_length, uint next_flag,
        zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_groups_searched_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_groups_searched_callback(System.IntPtr handle,
            zim_on_groups_searched_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_search_local_groups", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_search_local_groups(System.IntPtr handle,
            zim_group_search_config config, ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_group_members_searched_callback(
        System.IntPtr handle, [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
        System.IntPtr user_list, uint user_list_length, uint next_flag,
        zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_group_members_searched_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_group_members_searched_callback(System.IntPtr handle,
            zim_on_group_members_searched_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_search_local_group_members", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_search_local_group_members(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            zim_group_member_search_config config, ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void on_message_reaction_added_callback(
        System.IntPtr handle, zim_message_reaction reaction,
        zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_message_added_reaction_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_message_added_reaction_callback(System.IntPtr handle,
            on_message_reaction_added_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_add_message_reaction", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_add_message_reaction(System.IntPtr handle, [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string reaction_type,
            zim_message message, ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void on_message_reaction_deleted_callback(
        System.IntPtr handle, zim_message_reaction reaction,
        zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_message_deleted_reaction_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_message_deleted_reaction_callback(System.IntPtr handle,
            on_message_reaction_deleted_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_delete_message_reaction", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_delete_message_reaction(System.IntPtr handle, [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string reaction_type,
            zim_message message, ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void on_message_reaction_users_queried_callback(
        System.IntPtr handle, zim_message message, [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string reaction_type,
        System.IntPtr user_infos, uint user_info_length, long next_flag, uint total_count,
        zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_message_queried_reaction_user_list_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_message_queried_reaction_user_list_callback(System.IntPtr handle,
            on_message_reaction_users_queried_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_query_message_reaction_user_list", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_query_message_reaction_user_list(System.IntPtr handle,
            zim_message message, zim_message_reaction_users_query_config config, ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_message_reactions_changed_event(System.IntPtr handle,
    System.IntPtr reactions, uint reaction_length);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_message_reactions_changed_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_message_reactions_changed_event(System.IntPtr handle,
            zim_on_message_reactions_changed_event callback_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_conversation_unread_message_count_cleared_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string conversation_id, System.Int32 conversation_type,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_conversation_unread_message_count_cleared_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_conversation_unread_message_count_cleared_callback(System.IntPtr handle,
            zim_on_conversation_unread_message_count_cleared_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_clear_conversation_unread_message_count", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_clear_conversation_unread_message_count(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string conversation_id, System.Int32 conversation_type, ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_conversation_notification_status_set_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string converstaion_id, System.Int32 conversation_type,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_conversation_notification_status_set_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_conversation_notification_status_set_callback(System.IntPtr handle,
            zim_on_conversation_notification_status_set_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_set_conversation_notification_status", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_set_conversation_notification_status(System.IntPtr handle,
            System.Int32 status, [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string conversation_id,
            System.Int32 conversation_type, ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_conversation_message_receipt_read_sent_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string conversation_id, System.Int32 conversation_type,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_conversation_message_receipt_read_sent_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_conversation_message_receipt_read_sent_callback(System.IntPtr handle,
            zim_on_conversation_message_receipt_read_sent_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_send_conversation_message_receipt_read", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_send_conversation_message_receipt_read(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string conversation_id, System.Int32 conversation_type,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_message_sent_callback(System.IntPtr handle,
            zim_message message, zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_message_sent_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_message_sent_callback(System.IntPtr handle,
            zim_on_message_sent_callback callback_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_message_attached_callback(System.IntPtr handle,
            zim_message message, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_message_attached_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_message_attached_callback(System.IntPtr handle,
            zim_on_message_attached_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_send_message", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_send_message(System.IntPtr handle, zim_message message,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string to_conversation_id,
            System.Int32 conversation_type, zim_message_send_config config, ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_media_uploading_progress_callback(System.IntPtr handle, zim_message message, long current_file_size,
            long total_file_size, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_media_uploading_progress_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_media_uploading_progress_callback(System.IntPtr handle,
            zim_on_media_uploading_progress_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_send_media_message", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_send_media_message(System.IntPtr handle, zim_message message,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string to_conversation_id,
            System.Int32 conversation_type, zim_message_send_config config, ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_media_downloading_progress_callback(System.IntPtr handle, zim_message message,
            long current_file_size, long total_file_size, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_media_downloading_progress_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_media_downloading_progress_callback(System.IntPtr handle,
            zim_on_media_downloading_progress_callback callback_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_media_downloaded_callback(System.IntPtr handle, zim_message message, zim_error error_info,
                                                 int sequence);
        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_media_downloaded_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_media_downloaded_callback(System.IntPtr handle,
            zim_on_media_downloaded_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_download_media_file", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_download_media_file(System.IntPtr handle, zim_message message,
            System.Int32 file_type, ref int sequence);
        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_message_queried_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string conversation_id,
            System.Int32 conversation_type, System.IntPtr message_list,
            uint message_list_length, zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_message_queried_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_message_queried_callback(System.IntPtr handle,
            zim_on_message_queried_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_query_history_message", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_query_history_message(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string conversation_id,
            System.Int32 conversation_type, zim_message_query_config config,
            ref int sequence);
        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_message_deleted_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string conversation_id,
            System.Int32 conversation_type,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_message_deleted_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_message_deleted_callback(System.IntPtr handle,
            zim_on_message_deleted_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_delete_messages", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_delete_messages(System.IntPtr handle,
            System.IntPtr message_list, uint member_list_length,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string conversation_id,
            System.Int32 conversation_type,
            zim_message_delete_config config, ref int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_delete_all_message", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_delete_all_message(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string conversation_id,
            System.Int32 conversation_type,
            zim_message_delete_config config, ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_message_inserted_callback(System.IntPtr handle,
            zim_message message, zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_message_inserted_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_message_inserted_callback(System.IntPtr handle,
            zim_on_message_inserted_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_insert_message_to_local_db", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_insert_message_to_local_db(System.IntPtr handle, zim_message message,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string conversation_id,
            System.Int32 conversation_type,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string sender_user_id,
             ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_message_receipts_read_sent_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string conversation_id,
            System.Int32 conversation_type,
            System.IntPtr error_message_id_list, uint error_message_id_list_length,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_message_receipts_read_sent_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_message_receipts_read_sent_callback(System.IntPtr handle,
            zim_on_message_receipts_read_sent_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_send_message_receipts_read", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_send_message_receipts_read(System.IntPtr handle, System.IntPtr message_list,
            uint message_list_length,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string conversation_id,
            System.Int32 conversation_type, ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_message_receipts_info_queried_callback(System.IntPtr handle,
            System.IntPtr receipt_infos_list_ptr,
            uint receipt_info_list_length,
            IntPtr error_message_id_list_ptr,
            uint error_message_id_list_length,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_message_receipts_info_queried_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_message_receipts_info_queried_callback(System.IntPtr handle,
            zim_on_message_receipts_info_queried_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_query_message_receipts_info", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_query_message_receipts_info(System.IntPtr handle,
            System.IntPtr message_list, uint message_list_length,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string conversation_id,
            System.Int32 conversation_type, ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_message_revoked_callback(System.IntPtr handle, zim_message message,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_message_revoked_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_message_revoked_callback(System.IntPtr handle,
            zim_on_message_revoked_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_revoke_message", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_revoke_message(System.IntPtr handle,
            zim_message message, zim_message_revoke_config config, ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_room_created_callback(System.IntPtr handle,
            zim_room_full_info room_info,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_room_created_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_room_created_callback(System.IntPtr handle,
            zim_on_room_created_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_create_room", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_create_room(System.IntPtr handle, zim_room_info room_info,
            ref zim_room_advanced_config config,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_room_joined_callback(System.IntPtr handle,
            zim_room_full_info room_info,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_room_joined_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_room_joined_callback(System.IntPtr handle,
            zim_on_room_joined_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_join_room", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_join_room(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string room_id,
            ref int sequence);
        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_room_entered_callback(System.IntPtr handle,
            zim_room_full_info room_info,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_room_entered_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_room_entered_callback(System.IntPtr handle,
            zim_on_room_entered_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_enter_room", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_enter_room(System.IntPtr handle,
            zim_room_info room_info, ref zim_room_advanced_config config,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_room_left_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string room_id,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_room_left_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_room_left_callback(System.IntPtr handle,
            zim_on_room_left_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_leave_room", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_leave_room(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string room_id,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_room_member_queried_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string room_id,
            System.IntPtr user_list, uint user_list_length,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string next_flag,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_room_member_queried_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_room_member_queried_callback(System.IntPtr handle,
            zim_on_room_member_queried_callback callback_function);
        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_query_room_member_list", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_query_room_member_list(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string room_id,
            zim_room_member_query_config config,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_room_members_queried(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string room_id,
            System.IntPtr user_list_ptr, uint user_list_length,
            System.IntPtr error_user_list, uint error_user_list_length,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_room_members_queried_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_room_members_queried_callback(System.IntPtr handle,
            zim_on_room_members_queried callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_query_room_members", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_query_room_members(System.IntPtr handle, [MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 3)] string[] user_list, uint user_ids_length,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string room_id,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_room_online_member_count_queried_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string room_id,
            uint count, zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_room_online_member_count_queried_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_room_online_member_count_queried_callback(System.IntPtr handle,
            zim_on_room_online_member_count_queried_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_query_room_online_member_count", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_query_room_online_member_count(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string room_id,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_room_attributes_operated_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string room_id,
            System.IntPtr error_key_list_ptr, uint error_key_list_length, zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_room_attributes_operated_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_room_attributes_operated_callback(System.IntPtr handle,
            zim_on_room_attributes_operated_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_set_room_attributes", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_set_room_attributes(System.IntPtr handle,
            System.IntPtr room_attributes, uint room_attributes_length,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string room_id,
            zim_room_attributes_set_config config, ref int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_delete_room_attributes", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_delete_room_attributes(System.IntPtr handle,
            [MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 3)] string[] keys, uint keys_length,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string room_id,
            zim_room_attributes_delete_config config, ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_room_attributes_batch_operated_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string room_id,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_room_attributes_batch_operated_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_room_attributes_batch_operated_callback(System.IntPtr handle,
            zim_on_room_attributes_batch_operated_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_begin_room_attributes_batch_operation", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_begin_room_attributes_batch_operation(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string room_id,
            zim_room_attributes_batch_operation_config config, ref int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_end_room_attributes_batch_operation", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_end_room_attributes_batch_operation(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string room_id,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_room_attributes_queried_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string room_id,
            System.IntPtr room_attributes,
            uint room_attributes_length,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_room_attributes_queried_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_room_attributes_queried_callback(System.IntPtr handle,
            zim_on_room_attributes_queried_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_query_room_all_attributes", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_query_room_all_attributes(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string room_id,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_room_members_attributes_operated_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string room_id,
            System.IntPtr infos, uint infos_length,
            System.IntPtr error_user_list_ptr, uint error_user_list_length,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_room_members_attributes_operated_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_room_members_attributes_operated_callback(System.IntPtr handle,
            zim_on_room_members_attributes_operated_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_set_room_members_attributes", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_set_room_members_attributes(System.IntPtr handle,
            IntPtr attributes, uint attributes_length,
            [MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 3)] string[] user_ids, uint user_ids_length,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string room_id,
            zim_room_member_attributes_set_config config, ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_room_members_attributes_queried_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string room_id,
            System.IntPtr infos, uint infos_length,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_room_members_attributes_queried_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_room_members_attributes_queried_callback(System.IntPtr handle,
            zim_on_room_members_attributes_queried_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_query_room_members_attributes", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_query_room_members_attributes(System.IntPtr handle,
            [MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 3)] string[] user_ids, uint user_ids_length,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string room_id,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_room_member_attributes_list_queried_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string room_id,
            System.IntPtr infos_ptr, uint infos_length,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string next_flag,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_room_member_attributes_list_queried_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_room_member_attributes_list_queried_callback(System.IntPtr handle,
            zim_on_room_member_attributes_list_queried_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_query_room_member_attributes_list", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_query_room_member_attributes_list(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string room_id,
            zim_room_member_attributes_query_config config, ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_group_created_callback(System.IntPtr handle,
            zim_group_full_info group_info, IntPtr user_list_ptr,
            uint user_list_length, IntPtr error_user_list_ptr,
            uint error_user_list_length,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_group_created_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_group_created_callback(System.IntPtr handle,
            zim_on_group_created_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_create_group", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_create_group(System.IntPtr handle,
            zim_group_info group_info,
            [MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 3)] string[] user_ids,
            uint user_ids_length,
            ref zim_group_advanced_config config, ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_group_dismissed_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_group_dismissed_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_group_dismissed_callback(System.IntPtr handle,
            zim_on_group_dismissed_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_dismiss_group", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_dismiss_group(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_group_joined_callback(System.IntPtr handle,
            zim_group_full_info group_info,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_group_joined_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_group_joined_callback(System.IntPtr handle,
            zim_on_group_joined_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_join_group", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_join_group(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_group_left_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_group_left_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_group_left_callback(System.IntPtr handle,
            zim_on_group_left_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_leave_group", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_leave_group(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_group_users_invited_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            System.IntPtr user_list, uint user_list_length,
            System.IntPtr error_user_list, uint error_user_list_length,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_group_users_invited_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_group_users_invited_callback(System.IntPtr handle,
            zim_on_group_users_invited_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_invite_users_into_group", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_invite_users_into_group(System.IntPtr handle,
            [MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 3)] string[] user_ids, uint user_ids_length,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_group_member_kicked_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            System.IntPtr kicked_user_id_list, uint kicked_user_id_list_length,
            System.IntPtr error_user_list, uint error_user_list_length,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_group_member_kicked_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_group_member_kicked_callback(System.IntPtr handle,
            zim_on_group_member_kicked_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_kick_group_members", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_kick_group_members(System.IntPtr handle,
            [MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 3)] string[] user_ids, uint user_ids_length,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_group_owner_transferred_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string to_user_id,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_group_owner_transferred_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_group_owner_transferred_callback(System.IntPtr handle,
            zim_on_group_owner_transferred_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_transfer_group_owner", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_transfer_group_owner(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string to_user_id,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_group_name_updated_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_name,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_group_name_updated_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_group_name_updated_callback(System.IntPtr handle,
            zim_on_group_name_updated_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_update_group_name", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_update_group_name(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_name,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_group_avatar_url_updated_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_avatar_url,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_group_avatar_url_updated_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_group_avatar_url_updated_callback(System.IntPtr handle,
            zim_on_group_avatar_url_updated_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_update_group_avatar_url", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_update_group_avatar_url(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_avatar_url,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_group_notice_updated_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_notice,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_group_notice_updated_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_group_notice_updated_callback(System.IntPtr handle,
            zim_on_group_notice_updated_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_update_group_notice", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_update_group_notice(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_notice,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_group_info_queried_callback(System.IntPtr handle,
            zim_group_full_info group_info,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_group_info_queried_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_group_info_queried_callback(System.IntPtr handle,
            zim_on_group_info_queried_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_query_group_info", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_query_group_info(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_group_attributes_operated_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            System.IntPtr error_keys, uint error_keys_length,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_group_attributes_operated_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_group_attributes_operated_callback(System.IntPtr handle,
            zim_on_group_attributes_operated_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_set_group_attributes", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_set_group_attributes(System.IntPtr handle,
            System.IntPtr group_attributes, uint group_attributes_length,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            ref int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_delete_group_attributes", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_delete_group_attributes(System.IntPtr handle,
            [MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 3)] string[] keys, uint keys_length,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_group_attributes_queried_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            System.IntPtr group_attributes, uint group_attributes_length,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_group_attributes_queried_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_group_attributes_queried_callback(System.IntPtr handle,
            zim_on_group_attributes_queried_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_query_group_attributes", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_query_group_attributes(System.IntPtr handle,
            [MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 3)] string[] keys, uint keys_length,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            ref int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_query_group_all_attributes", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_query_group_all_attributes(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_group_member_nickname_updated_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string for_user_id,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string nickname,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_group_member_nickname_updated_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_group_member_nickname_updated_callback(System.IntPtr handle,
            zim_on_group_member_nickname_updated_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_set_group_member_nickname", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_set_group_member_nickname(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_member_nickname,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string for_user_id,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_group_member_role_updated_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string for_user_id,
            int role,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_group_member_role_updated_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_group_member_role_updated_callback(System.IntPtr handle,
            zim_on_group_member_role_updated_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_set_group_member_role", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_set_group_member_role(System.IntPtr handle, int role,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string for_user_id,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_group_member_info_queried_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            zim_group_member_info user_info,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_group_member_info_queried_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_group_member_info_queried_callback(System.IntPtr handle,
            zim_on_group_member_info_queried_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_query_group_member_info", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_query_group_member_info(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string user_id,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_group_list_queried_callback(System.IntPtr handle,
            System.IntPtr group_list,
            uint group_list_length, zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_group_list_queried_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_group_list_queried_callback(System.IntPtr handle,
            zim_on_group_list_queried_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_query_group_list", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_query_group_list(System.IntPtr handle,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_group_member_list_queried_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            System.IntPtr user_list,
            uint user_list_length, uint next_flag,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_group_member_list_queried_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_group_member_list_queried_callback(System.IntPtr handle,
            zim_on_group_member_list_queried_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_query_group_member_list", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_query_group_member_list(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            zim_group_member_query_config config,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_group_member_count_queried_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            uint count, zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_group_member_count_queried_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_group_member_count_queried_callback(System.IntPtr handle,
            zim_on_group_member_count_queried_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_query_group_member_count", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_query_group_member_count(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_group_message_receipt_member_list_queried_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            System.IntPtr user_list, uint user_list_length, uint next_flag,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_group_message_receipt_member_list_queried_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_group_message_receipt_member_list_queried_callback(System.IntPtr handle,
            zim_on_group_message_receipt_member_list_queried_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_query_group_message_receipt_read_member_list", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_query_group_message_receipt_read_member_list(System.IntPtr handle,
            zim_message message,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            zim_group_message_receipt_member_query_config config, ref int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_query_group_message_receipt_unread_member_list", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_query_group_message_receipt_unread_member_list(System.IntPtr handle,
            zim_message message,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id,
            zim_group_message_receipt_member_query_config config, ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_call_invitation_sent_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string call_id,
            zim_call_invitation_sent_info info,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_call_invitation_sent_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_call_invitation_sent_callback(System.IntPtr handle,
            zim_on_call_invitation_sent_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_call_invite", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_call_invite(System.IntPtr handle,
            [MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 3)] string[] invitees, uint invitees_length,
            zim_call_invite_config config, ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_calling_invitation_sent_callback(System.IntPtr handle,
                    [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string call_id,
                    zim_calling_invitation_sent_info info,
                    zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_calling_invitation_sent_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_calling_invitation_sent_callback(System.IntPtr handle,
            zim_on_calling_invitation_sent_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_calling_invite", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_calling_invite(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string call_id,
            [MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 3)] string[] invitees, uint invitees_length,
            zim_calling_invite_config config, ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_call_quit_sent_callback(System.IntPtr handle,
                    [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string call_id,
                    zim_call_quit_sent_info info,
                    zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_call_quit_sent_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_call_quit_sent_callback(System.IntPtr handle,
            zim_on_call_quit_sent_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_call_quit", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_call_quit(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string call_id,
            zim_call_quit_config config, ref int sequence);



        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_call_end_sent_callback(System.IntPtr handle,
                    [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string call_id,
                    zim_call_end_sent_info info,
                    zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_call_end_sent_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_call_end_sent_callback(System.IntPtr handle,
            zim_on_call_end_sent_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_call_end", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_call_end(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string call_id,
            zim_call_end_config config, ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_call_list_queried_callback(System.IntPtr handle,
                    System.IntPtr call_list, uint call_list_length, long next_flag,
                    zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_call_list_queried_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_call_list_queried_callback(System.IntPtr handle,
            zim_on_call_list_queried_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_query_call_list", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_query_call_list(System.IntPtr handle,
            zim_query_call_list_config config, ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_call_cancel_sent_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string call_id,
            System.IntPtr error_invitees_ptr, uint error_invitees_length,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_call_cancel_sent_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_call_cancel_sent_callback(System.IntPtr handle,
            zim_on_call_cancel_sent_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_call_cancel", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_call_cancel(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string call_id,
            [MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 3)] string[] invitees, uint invitees_length, zim_call_cancel_config config,
            ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_call_acceptance_sent_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string call_id,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_call_acceptance_sent_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_call_acceptance_sent_callback(System.IntPtr handle,
            zim_on_call_acceptance_sent_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_call_accept", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_call_accept(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string call_id,
            zim_call_accept_config config, ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_call_rejection_sent_callback(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string call_id,
            zim_error error_info, int sequence);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_call_rejection_sent_callback", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_call_rejection_sent_callback(System.IntPtr handle,
            zim_on_call_rejection_sent_callback callback_function);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_call_reject", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_call_reject(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string call_id,
            zim_call_reject_config config, ref int sequence);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_error_event(System.IntPtr handle,
            zim_error error_info);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_error_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_error_event(System.IntPtr handle,
            zim_on_error_event callback_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_connection_state_changed_event(System.IntPtr handle,
            System.Int32 state, System.Int32 connection_event,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string extended_data);
        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_connection_state_changed_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_connection_state_changed_event(System.IntPtr handle,
            zim_on_connection_state_changed_event event_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_token_will_expire_event(System.IntPtr handle,
            uint second);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_token_will_expire_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_token_will_expire_event(System.IntPtr handle,
        zim_on_token_will_expire_event event_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_conversation_changed_event(System.IntPtr handle,
            System.IntPtr infos, uint infos_length);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_conversation_changed_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_conversation_changed_event(System.IntPtr handle,
            zim_on_conversation_changed_event callback_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_conversation_total_unread_message_count_updated_event(System.IntPtr handle,
            uint total_unread_message_count);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_conversation_total_unread_message_count_updated_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_conversation_total_unread_message_count_updated_event(System.IntPtr handle,
            zim_on_conversation_total_unread_message_count_updated_event callback_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_receive_peer_message_event(System.IntPtr handle,
            System.IntPtr message_list, uint message_list_length,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string from_user_id);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_receive_peer_message_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_receive_peer_message_event(System.IntPtr handle,
            zim_on_receive_peer_message_event event_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_receive_room_message_event(System.IntPtr handle,
            System.IntPtr message_list, uint message_list_length,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string from_room_id);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_receive_room_message_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_receive_room_message_event(System.IntPtr handle,
            zim_on_receive_room_message_event event_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_receive_group_message_event(System.IntPtr handle,
            System.IntPtr message_list, uint message_list_length,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string from_group_id);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_receive_group_message_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_receive_group_message_event(System.IntPtr handle,
            zim_on_receive_group_message_event event_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_message_sent_status_changed_event(System.IntPtr handle,
            System.IntPtr infos_list_ptr, uint infos_list_length);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_message_sent_status_changed_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_message_sent_status_changed_event(System.IntPtr handle,
            zim_on_message_sent_status_changed_event event_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_message_receipt_changed_event(System.IntPtr handle,
            bool is_conv_read, System.IntPtr infos, uint infos_length);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_message_receipt_changed_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_message_receipt_changed_event(System.IntPtr handle,
            zim_on_message_receipt_changed_event event_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_message_revoke_received_event(System.IntPtr handle,
            System.IntPtr message_list, uint message_list_length);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_message_revoke_received_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_message_revoke_received_event(System.IntPtr handle,
            zim_on_message_revoke_received_event callback_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_broadcast_message_received_event(System.IntPtr handle,
        zim_message message);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_broadcast_message_received_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_broadcast_message_received_event(System.IntPtr handle,
    zim_on_broadcast_message_received_event callback_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_room_state_changed_event(System.IntPtr handle,
            System.Int32 state, System.Int32 room_event,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string extended_data,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string room_id);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_room_state_changed_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_room_state_changed_event(System.IntPtr handle,
            zim_on_room_state_changed_event event_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_room_member_joined_event(System.IntPtr handle,
            System.IntPtr member_list, uint member_list_length,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string room_id);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_room_member_joined_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_room_member_joined_event(System.IntPtr handle,
            zim_on_room_member_joined_event callback_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_room_member_left_event(System.IntPtr handle,
            System.IntPtr member_list, uint member_list_length,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string room_id);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_room_member_left_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_room_member_left_event(System.IntPtr handle,
            zim_on_room_member_left_event event_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_room_attributes_updated_event(System.IntPtr handle, [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string room_id,
            zim_room_attributes_update_info info,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string extended_data);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_room_attributes_updated_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_room_attributes_updated_event(System.IntPtr handle,
            zim_on_room_attributes_updated_event event_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_room_attributes_batch_updated_event(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string room_id,
            System.IntPtr infos_ptr, uint infos_length,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string extended_data);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_room_attributes_batch_updated_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_room_attributes_batch_updated_event(System.IntPtr handle,
            zim_on_room_attributes_batch_updated_event event_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_room_member_attributes_updated_event(System.IntPtr handle,
            System.IntPtr infos_ptr, uint infos_length, zim_room_operated_info operated_info,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string room_id);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_room_member_attributes_updated_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_room_member_attributes_updated_event(System.IntPtr handle,
            zim_on_room_member_attributes_updated_event event_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_group_state_changed_event(System.IntPtr handle,
            System.Int32 state, System.Int32 group_event,
            zim_group_operated_info operated_info,
            zim_group_full_info group_info);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_group_state_changed_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_group_state_changed_event(System.IntPtr handle,
            zim_on_group_state_changed_event event_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_group_member_state_changed_event(System.IntPtr handle,
            System.Int32 state, System.Int32 group_member_event,
            System.IntPtr user_list, uint user_list_length,
            zim_group_operated_info operated_info,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_group_member_state_changed_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_group_member_state_changed_event(System.IntPtr handle,
            zim_on_group_member_state_changed_event event_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_group_name_updated_event(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_name,
            zim_group_operated_info operated_info,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_group_name_updated_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_group_name_updated_event(System.IntPtr handle,
            zim_on_group_name_updated_event event_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_group_notice_updated_event(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_notice,
            zim_group_operated_info operated_info,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_group_notice_updated_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_group_notice_updated_event(System.IntPtr handle,
            zim_on_group_notice_updated_event callback_function);


        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_group_avatar_url_updated_event(System.IntPtr handle,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_avatar_url,
            zim_group_operated_info operated_info,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_group_avatar_url_updated_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_group_avatar_url_updated_event(System.IntPtr handle,
            zim_on_group_avatar_url_updated_event event_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_group_attributes_updated_event(System.IntPtr handle,
            System.IntPtr infos, uint infos_length,
            zim_group_operated_info operated_info,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_group_attributes_updated_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_group_attributes_updated_event(System.IntPtr handle,
            zim_on_group_attributes_updated_event callback_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_group_member_info_updated_event(System.IntPtr handle,
            System.IntPtr user_infos, uint user_infos_length,
            zim_group_operated_info operated_info,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string group_id);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_group_member_info_updated_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_group_member_info_updated_event(System.IntPtr handle,
            zim_on_group_member_info_updated_event event_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_call_invitation_received_event(System.IntPtr handle,
            zim_call_invitation_received_info info,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string call_id);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_call_invitation_received_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_call_invitation_received_event(System.IntPtr handle,
            zim_on_call_invitation_received_event event_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_call_invitation_cancelled_event(System.IntPtr handle,
            zim_call_invitation_cancelled_info info,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string call_id);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_call_invitation_cancelled_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_call_invitation_cancelled_event(System.IntPtr handle,
            zim_on_call_invitation_cancelled_event event_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_call_invitation_accepted_event(System.IntPtr handle,
            zim_call_invitation_accepted_info info,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string call_id);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_call_invitation_accepted_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_call_invitation_accepted_event(System.IntPtr handle,
            zim_on_call_invitation_accepted_event event_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_call_invitation_rejected_event(System.IntPtr handle,
            zim_call_invitation_rejected_info info,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string call_id);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_call_invitation_rejected_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_call_invitation_rejected_event(System.IntPtr handle,
            zim_on_call_invitation_rejected_event event_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_call_invitation_timeout_event(System.IntPtr handle,
            zim_call_invitation_timeout_info info,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string call_id);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_call_invitation_timeout_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_call_invitation_timeout_event(System.IntPtr handle,
            zim_on_call_invitation_timeout_event event_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_call_invitees_answered_timeout_event(System.IntPtr handle,
            System.IntPtr invitees_ptr, uint invitees_length,
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string call_id);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_call_invitees_answered_timeout_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_call_invitees_answered_timeout_event(System.IntPtr handle,
            zim_on_call_invitees_answered_timeout_event event_function);


        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_call_invitation_ended_event(System.IntPtr handle,
            zim_call_invitation_ended_info info, 
            [In()][MarshalAs(UnmanagedType.CustomMarshaler, MarshalTypeRef = typeof(ZIMUtil.UTF8StringMarshaler))] string call_id);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_call_invitation_ended_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_call_invitation_ended_event(System.IntPtr handle,
            zim_on_call_invitation_ended_event event_function);

        [UnmanagedFunctionPointer(ZIMConstans.ZIM_CALLINGCONVENTION)]
        public delegate void zim_on_call_user_state_changed_event(System.IntPtr handle,
            zim_event_call_user_state_changed_info info);

        [DllImportAttribute(ZIMConstans.LIB_NAME, EntryPoint = "zim_register_call_user_state_changed_event", CallingConvention = ZIMConstans.ZIM_CALLINGCONVENTION)]
        public static extern void zim_register_call_user_state_changed_event(System.IntPtr handle,
            zim_on_call_user_state_changed_event event_function);
    }
}
